﻿Imports System.Math
Public Module Other
    Public Sub doTalentCheck()
        If (Form1.Talent_Concussion.Text <> "0") Then Variables.TalentsHash.Item("Concuss") = CDec(1.0 + (CDbl(Form1.Talent_Concussion.Text) / 50)) Else Variables.TalentsHash.Item("Concuss") = CDec(1.0)
        If (Form1.Talent_ElementalPrecision.Text <> "0") Then Variables.TalentsHash.Item("ElePrec") = CDec(Form1.Talent_ElementalPrecision.Text / 100) Else Variables.TalentsHash.Item("ElePrec") = CDec(0.0)
        If (Form1.Talent_CallofFlame.Text <> "0") Then Variables.TalentsHash.Item("CallFla") = CDbl(Form1.Talent_CallofFlame.Text) * 0.05 Else Variables.TalentsHash.Item("CallFla") = CDec(1.0)
        If (Form1.Talent_LavaSurge.Text <> "0") Then Variables.TalentsHash.Item("LavaSurge") = Form1.Talent_LavaSurge.Text * 10 Else Variables.TalentsHash.Item("LavaSurge") = 0
        If (Form1.Talent_Fulmination.Text <> "0") Then Variables.TalentsHash.Item("Fulmination") = 1 Else Variables.TalentsHash.Item("Fulmination") = 0
        If (Form1.Talent_RollingThunder.Text <> "0") Then Variables.TalentsHash.Item("RollingThunder") = Form1.Talent_RollingThunder.Text * 30 Else Variables.TalentsHash.Item("RollingThunder") = 0

        If (Form1.Talent_LavaFlows.Text <> "0") Then
            If (Form1.Talent_LavaFlows.Text = "1") Then
                Variables.TalentsHash.Item("LavaFlo") = CDec(0.06)
                Variables.TalentsHash.Item("LavaDoT") = CDec(0.2)
            ElseIf (Form1.Talent_LavaFlows.Text = "2") Then
                Variables.TalentsHash.Item("LavaFlo") = CDec(0.12)
                Variables.TalentsHash.Item("LavaDoT") = CDec(0.4)
            ElseIf (Form1.Talent_LavaFlows.Text = "3") Then
                Variables.TalentsHash.Item("LavaFlo") = CDec(0.24)
                Variables.TalentsHash.Item("LavaDoT") = CDec(0.6)
            End If
        Else
            Variables.TalentsHash.Item("LavaFlo") = CDec(0.0)
            Variables.TalentsHash.Item("LavaDoT") = CDec(0.0)
        End If

        ' Mastery has a base 16% (8.00 Mastery), then stats from gear increase the chance for Elemental Overload.
        ' Each point of Mastery is 2% added to Elemental Overload chance.
        Variables.StoredEleOverChance = 16 + (Round((Variables.StoredMastRate / CDec(Variables.Ratings.Item("Mastery85"))), 2) * 2)

        If (Form1.CurseofElements.Checked) Then Variables.TalentsHash.Item("CurseOE") = CDec(1.08) Else Variables.TalentsHash.Item("CurseOE") = 1
        If (Form1.WintersChill.Checked) Then Variables.TalentsHash.Item("Winters") = 5 Else Variables.TalentsHash.Item("Winters") = 0
        If (Form1.Heroism.Checked) Then Variables.StoredHeroism = True Else Variables.StoredHeroism = False
        If (Form1.WrathofAir.Checked) Then Variables.StoredWoACheck = 1 Else Variables.StoredWoACheck = 0
    End Sub

    Public Sub doSimulationRun(Optional ByVal worker As System.ComponentModel.BackgroundWorker = Nothing)
        Variables.rawDamage.Clear()

        Dim castLB As Byte = 0
        Dim castCL As Byte = 0
        Dim castFS As Byte = 0
        Dim castLvB As Byte = 0
        Dim castUE As Byte = 0
        Dim castES As Byte = 0
        If (Variables.SpellsToCast.Item("LB") = 1) Then castLB = 1
        If (Variables.SpellsToCast.Item("CL") = 1) Then castCL = 1
        If (Variables.SpellsToCast.Item("FS") = 1) Then castFS = 1
        If (Variables.SpellsToCast.Item("LvB") = 1) Then castLvB = 1
        If (Variables.SpellsToCast.Item("UE") = 1) Then castUE = 1
        If (Variables.SpellsToCast.Item("ES") = 1) Then castES = 1

        Dim extraSP As Integer = 0
        Dim extraHaste As Integer = 0

        Dim missPct As Decimal = getHitValue()

        ' Get Spell damage ranges.
        Dim lbinfo() As String = Split(Variables.Spells.Item("LB85"), ",")
        Dim lvbinfo() As String = Split(Variables.Spells.Item("LvB85"), ",")
        Dim fsinfo() As String = Split(Variables.Spells.Item("FS85"), ",")
        Dim clinfo() As String = Split(Variables.Spells.Item("CL85"), ",")
        Dim ueinfo() As String = Split(Variables.Spells.Item("UE85"), ",")
        Dim esinfo() As String = Split(Variables.Spells.Item("ES85"), ",")
        Dim fulinfo() As String = Split(Variables.Spells.Item("Ful85"), ",")

        ' Check for MetaGem crit bonus.
        If Variables.CurrentGems.Item("Head").ToString.Contains("34220") Or Variables.CurrentGems.Item("Head").ToString.Contains("41285") Then
            Variables.StoredMetaCrit = 1
        Else
            Variables.StoredMetaCrit = 0
        End If

        ' Time records of last casting of spells.
        Dim CLCastedTime As Decimal = 0
        Dim FSCastedTime As Decimal = 0
        Dim ESCastedTime As Decimal = 0
        Dim LvBCastedTime As Decimal = 0
        Dim UECastedTime As Decimal = 0
        Dim HeroismCastedTime As Decimal = 0

        ' Procs
        Dim CLEARCAST As Integer = 0 ' Lasts 2 casts
        Dim clearcastingstate As Byte = 0
        Dim clearcastingstart As Decimal = 0.0
        Dim eleoathbonus As Decimal = 1.1

        ' Get Hasted spell casting times.
        Dim HastedLBCastTime As Decimal = getHastedCast(Variables.StoredLBCast, 0, extraHaste)
        Dim HastedFSGCDTime As Decimal = getHastedCast(Variables.StoredFSGCD, 0, extraHaste)
        Dim HastedLvBCastTime As Decimal = getHastedCast(Variables.StoredLvBCast, 0, extraHaste)
        Dim HastedCLCastTime As Decimal = getHastedCast(Variables.StoredCLCast, 0, extraHaste)
        Dim HastedUECastTime As Decimal = getHastedCast(Variables.StoredUEGCD, 0, extraHaste)
        Dim HastedFSDoTTime As Decimal = getHastedCast(Variables.StoredFSDoTTime, 0, extraHaste)
        Dim HastedFSDoTInterval As Decimal = getHastedCast(3, 0, extraHaste)

        ' Cast time can never go below one second (Even though it does) because the GCD can never go below one second.
        If HastedLBCastTime < 1.0 Then HastedLBCastTime = 1.0
        If HastedFSGCDTime < 1.0 Then HastedFSGCDTime = 1.0
        If HastedLvBCastTime < 1.0 Then HastedLvBCastTime = 1.0
        If HastedCLCastTime < 1.0 Then HastedCLCastTime = 1.0
        If HastedUECastTime < 1.0 Then HastedUECastTime = 1.0

        ' Get Hasted spell casting times with Heroism up.
        Dim HastedLBCastTimeHero As Decimal = getHastedCast(Variables.StoredLBCast, 1, extraHaste)
        Dim HastedFSGCDTimeHero As Decimal = getHastedCast(Variables.StoredFSGCD, 1, extraHaste)
        Dim HastedLvBCastTimeHero As Decimal = getHastedCast(Variables.StoredLvBCast, 1, extraHaste)
        Dim HastedCLCastTimeHero As Decimal = getHastedCast(Variables.StoredCLCast, 1, extraHaste)
        Dim HastedUECastTimeHero As Decimal = getHastedCast(Variables.StoredUEGCD, 1, extraHaste)
        Dim HastedFSDoTTimeHero As Decimal = getHastedCast(Variables.StoredFSDoTTime, 1, extraHaste)
        Dim HastedFSDoTIntervalHero As Decimal = getHastedCast(3, 1, extraHaste)

        ' Cast time can never go below one second because of the GCD.
        If HastedLBCastTimeHero < 1.0 Then HastedLBCastTimeHero = 1.0
        If HastedFSGCDTimeHero < 1.0 Then HastedFSGCDTimeHero = 1.0
        If HastedLvBCastTimeHero < 1.0 Then HastedLvBCastTimeHero = 1.0
        If HastedCLCastTimeHero < 1.0 Then HastedCLCastTimeHero = 1.0
        If HastedUECastTimeHero < 1.0 Then HastedUECastTimeHero = 1.0

        If (Variables.StoredGoSCheck = 1) Then
            HastedFSGCDTime = 1.0
            HastedFSGCDTimeHero = 1.0
        End If

        Dim LBCastTime As Decimal = HastedLBCastTime
        Dim FSGCDTime As Decimal = HastedFSGCDTime
        Dim LvBCastTime As Decimal = HastedLvBCastTime
        Dim CLCastTime As Decimal = HastedCLCastTime
        Dim UECastTime As Decimal = HastedUECastTime
        Dim FSDoTInterval As Decimal = HastedFSDoTInterval

        Dim clcooldown As Integer = 3
        Dim fscooldown As Integer = 6
        Dim uecooldown As Integer = 15
        Dim shockcooldown As Decimal = 0

        Dim LSCharges As Integer = 3
        Dim ChargeBuildTime As Decimal = 0
        Dim FulminationCastTime As Decimal = 0

        Dim FlameShockActive As Byte = 0
        Dim FlameShockTickTime As Decimal = 0.0
        Dim FSCCActiveAtCast As Integer = 0
        Dim UnleashActive As Byte = 0
        Dim UnleashStart As Byte = 0
        Dim LvBInterrupt As Byte = 0

        Dim HeroismActive As Byte = 0 ' 1 is active, 0 is nonactive, 2 is already used.
        Dim HeroDebuff As Decimal = 0

        Dim Casting As Decimal = 0 ' Stores the time caster is locked in a casting event.
        Dim Busy As Decimal = 0 ' Stores the time when the caster is free to start another event. 
        Dim spellCast As Integer = 0 ' Stores what spell is casting.
        Dim currentTime As Decimal = 0.0

        Dim repProgress As Integer = 0

        Do While currentTime <= (Variables.StoredFightLength * 60)
            If Variables.StoredHeroism = True And (HeroDebuff + 600) < currentTime Then HeroismActive = 0 ' Clear Heroism Debuff
            ' Shut down Heroism
            If Variables.StoredHeroism = True And (HeroismCastedTime + 40) < currentTime And HeroismActive = 1 Then
                HeroismActive = 2
                ' Set casting times back to non-Heroism values.
                LBCastTime = HastedLBCastTime
                FSGCDTime = HastedFSGCDTime
                LvBCastTime = HastedLvBCastTime
                CLCastTime = HastedCLCastTime
                UECastTime = HastedUECastTime
                FSDoTInterval = HastedFSDoTInterval
                rawDamage.Add("13")
            End If
            ' Start up Heroism
            If Variables.StoredHeroism = True And HeroismActive = 0 Then
                HeroismActive = 1
                ' Set casting times to Heroism haste values.
                LBCastTime = HastedLBCastTimeHero
                FSGCDTime = HastedFSGCDTimeHero
                LvBCastTime = HastedLvBCastTimeHero
                CLCastTime = HastedCLCastTimeHero
                UECastTime = HastedUECastTimeHero
                FSDoTInterval = HastedFSDoTIntervalHero
                rawDamage.Add("12")
                HeroismCastedTime = currentTime
            End If

            ' Check for Clearcasting fade.
            If (clearcastingstate = 1 And clearcastingstart + 15 <= currentTime) Then
                Variables.rawDamage.Add("7")
                clearcastingstate = 0
            End If

            ' Check for Unleash Element buff fading.
            If (UnleashActive = 1 And (UECastedTime + 8) <= currentTime) Then UnleashActive = 0

            ' Check for Flame Shock ticks.
            If (FlameShockActive = 1 And (FlameShockTickTime + FSCastedTime + FSDoTInterval) <= currentTime) Then
                Dim FlameShockDoT() As String = Spells.doFlameShockDoT(fsinfo(3), (Variables.StoredSpellDmg + extraSP), FSCCActiveAtCast, eleoathbonus)
                Variables.rawDamage.Add("5," & FlameShockDoT(0) & "," & FlameShockDoT(1) & "," & clearcastingstate & "," & FSCastedTime + FlameShockTickTime + FSDoTInterval)
                FlameShockTickTime += FSDoTInterval
                If (Variables.TalentsHash.Item("LavaSurge") <> "0" And castLvB = 1) Then
                    Dim lsproc As Integer = RandomNumber(1, 100)
                    If (lsproc <= Variables.TalentsHash.Item("LavaSurge")) Then
                        Dim wasted = 0
                        Dim timeSaved As Decimal
                        If (LvBCastedTime = 0 Or (Busy <> 0 And spellCast = 3)) Then ' LvB hasn't even been casted yet.. What a waste.. / Or / LvB is being casted now.  Another waste.
                            wasted = 1
                            timeSaved = 0
                        Else
                            timeSaved = (LvBCastedTime + 8) - currentTime
                            If (timeSaved < 0) Then timeSaved = 0
                        End If
                        LvBInterrupt = 1
                        rawDamage.Add("15," & timeSaved & "," & wasted)
                    End If
                End If
            End If

            ' Check for Flame Shock fading off target.
            If (FlameShockActive = 1 And (FSCastedTime + Variables.StoredFSDoTTime) <= currentTime) Then
                rawDamage.Add("11")
                FlameShockActive = 0
                FlameShockTickTime = 0
            End If

            If (Busy <= currentTime) Then Busy = 0

            If (Busy = 0) Then
                If (castFS = 1 And FlameShockActive = 0 And shockcooldown <= currentTime And ((FSCastedTime = 0 Or (FSCastedTime + Variables.StoredFSDoTTime) <= currentTime) Or (FSCastedTime + fscooldown <= currentTime))) Then
                    rawDamage.Add("99,Flame Shock," & currentTime)
                    If clearcastingstate = 1 Then FSCCActiveAtCast = 1 Else FSCCActiveAtCast = 0
                    Spells.doFlameShock(missPct, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, FlameShockActive, eleoathbonus, fsinfo(0), fsinfo(1))
                    FSCastedTime = currentTime
                    shockcooldown = currentTime + 6
                    Busy = FSGCDTime + Variables.StoredInstantLatency + currentTime

                ElseIf (castES = 1 And LSCharges >= Variables.StoredFulmCharge And shockcooldown <= currentTime And (ESCastedTime = 0 Or (ESCastedTime + 6) <= currentTime) And (castFS = 0 Or FlameShockActive = 1 And (FSCastedTime + Variables.StoredFSDoTTime - 6) >= currentTime)) Then
                    rawDamage.Add("99,Earth Shock," & currentTime)
                    Spells.doEarthShock(missPct, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, eleoathbonus, esinfo(0), esinfo(1))
                    ESCastedTime = currentTime
                    shockcooldown = currentTime + 6
                    Busy = FSGCDTime + Variables.StoredInstantLatency + currentTime
                    If (Variables.TalentsHash.Item("Fulmination") = 1) Then
                        Spells.doFulmination(missPct, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, eleoathbonus, fulinfo(0), fulinfo(1), LSCharges, ChargeBuildTime)
                        LSCharges = 3
                        FulminationCastTime = currentTime
                        ChargeBuildTime = 0
                    End If

                ElseIf (castUE = 1 And UnleashActive = 0 And (castFS = 0 Or FlameShockActive = 1) And (LvBCastedTime = 0 Or (LvBCastedTime + 8) <= currentTime) And (UECastedTime = 0 Or (UECastedTime + uecooldown) <= currentTime)) Then
                    ' Make sure FS is on the target, and LvB is off cooldown instead of casting UE whenever it's available.  (Avoid the buff being eaten by Flame Shock)
                    rawDamage.Add("99,Unleash Elements," & currentTime)
                    Spells.doUnleashElements(missPct, currentTime, CLEARCAST, clearcastingstate, UnleashActive, eleoathbonus, ueinfo(0), ueinfo(1))
                    UECastedTime = currentTime
                    Busy = UECastTime + Variables.StoredInstantLatency + currentTime

                ElseIf (castLvB = 1 And ((LvBCastedTime = 0 Or (LvBCastedTime + 8) <= currentTime) Or LvBInterrupt = 1) And (FSCastedTime + Variables.StoredFSDoTTime - LvBCastTime) > currentTime) Then
                    rawDamage.Add("99,Lava Burst," & currentTime)
                    Casting = LvBCastTime + currentTime
                    Busy = LvBCastTime + Variables.StoredLatency + currentTime
                    spellCast = 3
                    LvBInterrupt = 0

                ElseIf (castCL = 1 And (CLCastedTime = 0 Or (CLCastedTime + clcooldown) <= currentTime)) Then
                    rawDamage.Add("99,Chain Lightning," & currentTime)
                    Casting = CLCastTime + currentTime
                    Busy = CLCastTime + Variables.StoredLatency + currentTime
                    spellCast = 2

                ElseIf (castLB = 1) Then
                    rawDamage.Add("99,Lightning Bolt," & currentTime)
                    Casting = LBCastTime + currentTime
                    Busy = LBCastTime + Variables.StoredLatency + currentTime
                    spellCast = 1
                End If
            End If

            If (Casting <= currentTime) Then
                If (spellCast > 0) Then
                    If (spellCast = 1) Then
                        Spells.doLightningBolt(missPct, 0, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, eleoathbonus, lbinfo(0), lbinfo(1), extraSP)
                        doRollingThunder(LSCharges, ChargeBuildTime, currentTime, FulminationCastTime)

                        Dim loproc As Integer = RandomNumber(1, 100)
                        If (loproc <= Variables.StoredEleOverChance) Then
                            Spells.doLightningBolt(missPct, 4, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, eleoathbonus, lbinfo(0), lbinfo(1), extraSP)
                            ' LB triggers Rolling Thunder as of 4.0.6
                            doRollingThunder(LSCharges, ChargeBuildTime, currentTime, FulminationCastTime)
                        End If

                    ElseIf (spellCast = 2) Then
                        Spells.doChainLightning(missPct, 3, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, eleoathbonus, clinfo(0), clinfo(1), extraSP)
                        CLCastedTime = currentTime
                        doRollingThunder(LSCharges, ChargeBuildTime, currentTime, FulminationCastTime)

                        Dim loproc As Integer = RandomNumber(1, 100)
                        If (loproc <= Variables.StoredEleOverChance) Then
                            Spells.doChainLightning(missPct, 4, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, eleoathbonus, clinfo(0), clinfo(1), extraSP)
                            ' CL triggers Rolling Thunder as of 4.0.6
                            doRollingThunder(LSCharges, ChargeBuildTime, currentTime, FulminationCastTime)
                        End If

                    ElseIf (spellCast = 3) Then
                        Spells.doLavaBurst(missPct, 1, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, FlameShockActive, eleoathbonus, UnleashActive, lvbinfo(0), lvbinfo(1))
                        LvBCastedTime = currentTime
                        Dim loproc As Integer = RandomNumber(1, 100)
                        If (loproc <= Variables.StoredEleOverChance) Then Spells.doLavaBurst(missPct, 4, currentTime, CLEARCAST, clearcastingstate, clearcastingstart, FlameShockActive, eleoathbonus, UnleashActive, lvbinfo(0), lvbinfo(1))
                    End If
                    spellCast = 0
                End If
            End If

            ' Increment a counter to send time updates back to the main thread.
            If (repProgress = 1000 And worker IsNot Nothing) Then
                worker.ReportProgress(1, currentTime.ToString)
                repProgress = 0
            Else
                repProgress += 1
            End If

            currentTime += 0.001
        Loop
    End Sub

    Public Sub doModelRun(Optional ByVal worker As System.ComponentModel.BackgroundWorker = Nothing)
        ' Clear Damage Array
        Variables.rawDamage.Clear()
        ' Toggle which spells to use.
        Dim castLB As Byte = 0
        Dim castCL As Byte = 0
        Dim castFS As Byte = 0
        Dim castLvB As Byte = 0
        Dim castUE As Byte = 0
        Dim castES As Byte = 0
        If (Variables.SpellsToCast.Item("LB") = 1) Then castLB = 1
        If (Variables.SpellsToCast.Item("CL") = 1) Then castCL = 1
        If (Variables.SpellsToCast.Item("FS") = 1) Then castFS = 1
        If (Variables.SpellsToCast.Item("LvB") = 1) Then castLvB = 1
        If (Variables.SpellsToCast.Item("UE") = 1) Then castUE = 1
        If (Variables.SpellsToCast.Item("ES") = 1) Then castES = 1

        Dim extraHaste As Integer = 0

        ' Miss Percent
        Dim missPct As Decimal = getHitValue()
        Dim hitPct As Decimal = (100 - missPct) / 100

        ' Modifed Crit Percent
        Dim critPcti As Decimal = Variables.StoredCritPerc + Variables.TalentsHash.Item("Winters")
        Dim critDec As Decimal = 1 + (critPcti / 100)

        ' Determine which spell level.
        Dim lbinfo() As String = Split(Variables.Spells.Item("LB85"), ",")
        Dim clinfo() As String = Split(Variables.Spells.Item("CL85"), ",")
        Dim fsinfo() As String = Split(Variables.Spells.Item("FS85"), ",")
        Dim lvbinfo() As String = Split(Variables.Spells.Item("LvB85"), ",")
        Dim ueinfo() As String = Split(Variables.Spells.Item("UE85"), ",")
        Dim esinfo() As String = Split(Variables.Spells.Item("ES85"), ",")
        Dim fulinfo() As String = Split(Variables.Spells.Item("Ful85"), ",")

        ' Check for MetaGem crit bonus.
        If (Variables.CurrentGems.Item("Head") <> "" And Variables.CurrentGems.Item("Head") <> "0;0;0") Then
            If Variables.CurrentGems.Item("Head").ToString.Contains("34220") Or Variables.CurrentGems.Item("Head").ToString.Contains("41285") Then
                Variables.StoredMetaCrit = 1
            Else
                Variables.StoredMetaCrit = 0
            End If
        End If

        ' Average damage bonus from Elemental Oath's addition to Clearcasting.
        Dim dmgbonus As Decimal = 1 + ((10 * Variables.StoredClearcastUp) / 100)

        ' Get Hasted spell casting times.
        Dim HastedLBCastTime As Decimal = getHastedCast(Variables.StoredLBCast, 0, extraHaste)
        Dim HastedFSGCDTime As Decimal = getHastedCast(Variables.StoredFSGCD, 0, extraHaste)
        Dim HastedLvBCastTime As Decimal = getHastedCast(Variables.StoredLvBCast, 0, extraHaste)
        Dim HastedCLCastTime As Decimal = getHastedCast(Variables.StoredCLCast, 0, extraHaste)
        Dim HastedUECastTime As Decimal = getHastedCast(Variables.StoredUEGCD, 0, extraHaste)
        Dim HastedFSDoTTime As Decimal = getHastedCast(Variables.StoredFSDoTTime, 0, extraHaste)
        Dim HastedFSDoTInterval As Decimal = getHastedCast(3, 0, extraHaste)

        ' Cast time can never go below one second (Even though it does) because the GCD can never go below one second.
        If HastedLBCastTime < 1.0 Then HastedLBCastTime = 1.0
        If HastedFSGCDTime < 1.0 Then HastedFSGCDTime = 1.0
        If HastedLvBCastTime < 1.0 Then HastedLvBCastTime = 1.0
        If HastedCLCastTime < 1.0 Then HastedCLCastTime = 1.0
        If HastedUECastTime < 1.0 Then HastedUECastTime = 1.0

        ' Get Hasted spell casting times with Heroism up.
        Dim HastedLBCastTimeHero As Decimal = getHastedCast(Variables.StoredLBCast, 1, extraHaste)
        Dim HastedFSGCDTimeHero As Decimal = getHastedCast(Variables.StoredFSGCD, 1, extraHaste)
        Dim HastedLvBCastTimeHero As Decimal = getHastedCast(Variables.StoredLvBCast, 1, extraHaste)
        Dim HastedCLCastTimeHero As Decimal = getHastedCast(Variables.StoredCLCast, 1, extraHaste)
        Dim HastedUECastTimeHero As Decimal = getHastedCast(Variables.StoredUEGCD, 1, extraHaste)
        Dim HastedFSDoTTimeHero As Decimal = getHastedCast(Variables.StoredFSDoTTime, 1, extraHaste)
        Dim HastedFSDoTIntervalHero As Decimal = getHastedCast(3, 1, extraHaste)

        ' Cast time can never go below one second because of the GCD.
        If HastedLBCastTimeHero < 1.0 Then HastedLBCastTimeHero = 1.0
        If HastedFSGCDTimeHero < 1.0 Then HastedFSGCDTimeHero = 1.0
        If HastedLvBCastTimeHero < 1.0 Then HastedLvBCastTimeHero = 1.0
        If HastedCLCastTimeHero < 1.0 Then HastedCLCastTimeHero = 1.0
        If HastedUECastTimeHero < 1.0 Then HastedUECastTimeHero = 1.0

        ' Glyph of Shocking
        If (Variables.StoredGoSCheck = 1) Then
            HastedFSGCDTime = 1.0
            HastedFSGCDTimeHero = 1.0
        End If

        ' Set base cast times.
        Dim LBCastTime As Decimal = HastedLBCastTime
        Dim FSGCDTime As Decimal = HastedFSGCDTime
        Dim LvBCastTime As Decimal = HastedLvBCastTime
        Dim CLCastTime As Decimal = HastedCLCastTime
        Dim FSDoTTime As Decimal = Variables.StoredFSDoTTime
        Dim FSDoTInterval As Decimal = HastedFSDoTInterval
        Dim UECastTime As Decimal = HastedUECastTime

        Dim uecooldown As Integer = 15
        Dim clcooldown As Integer = 3
        Dim lvbcooldown As Decimal = 8
        If (Variables.TalentsHash.Item("Lava Surge") <> "0") Then lvbcooldown -= StoredLSBenefit

        ' Fight length in seconds
        Dim modelFight As Decimal = Variables.StoredFightLength * 60

        Dim Casting As Decimal = 0 ' Stores the time caster is locked in a casting event.
        Dim Busy As Decimal = 0 ' Stores the time when the caster is free to start another event. 
        Dim spellCast As Integer = 0 ' Stores what spell is casting.
        Dim currentTime As Decimal = 0.0
        Dim FSCastedTime As Decimal = 0
        Dim LvBCastedTime As Decimal = 0
        Dim CLCastedTime As Decimal = 0
        Dim UECastedTime As Decimal = 0
        Dim ESCastedTime As Decimal = 0
        Dim HeroismCastedTime As Decimal = 0
        Dim spellDmg(8) As Integer ' LB, CL, FS, LvB, LO, FSDoT, UE, ES, Ful
        Dim numberofSpells(8) As Integer ' LB, CL, FS, LvB, LO, FSDoT, UE, ES, Ful
        Dim FlameShockActive As Integer = 0
        Dim FlameShockStart As Byte = 0
        Dim FlameShockTickTime As Decimal = 0
        Dim UnleashActive As Byte = 0
        Dim UnleashStart As Byte = 0
        Dim HeroismActive As Byte = 0
        Dim HeroDebuff As Decimal = 0
        Dim shockcooldown As Decimal = 0
        Dim DeadTime As Decimal = 0
        ' Damage in the model is consistant with each loop, so only run the functions to find the damage once.
        Dim LightningBoltModelDamage As Integer = Spells.doGenericSpellModel(lbinfo(2), critDec, hitPct, dmgbonus, "LB", 1)
        Dim ChainLightningModelDamage As Integer = Spells.doGenericSpellModel(clinfo(2), critDec, hitPct, dmgbonus, "CL", 1)
        Dim FlameShockModelDamage As Integer = Spells.doGenericSpellModel(fsinfo(2), critDec, hitPct, dmgbonus, "FS", 1)
        Dim LavaBurstModelDamage As Integer = Spells.doLavaBurstModel(lvbinfo(2), critDec, hitPct, dmgbonus)
        Dim UnleashElementsModelDamage As Integer = Spells.doGenericSpellModel(ueinfo(2), critDec, hitPct, dmgbonus, "UE", 0)
        Dim EarthShockModelDamage As Integer = Spells.doGenericSpellModel(esinfo(2), critDec, hitPct, dmgbonus, "ES", 1)
        Dim FulminationModelDamage As Integer = Spells.doGenericSpellModel(fulinfo(2), critDec, hitPct, dmgbonus, "Ful", 0)

        ' FlameShock DoT is a constant (Not in game, just in this program)
        ' It should be rewritten to account for the damage bonus of Clearcasting procs.  But I'm lazy!
        Dim FlameShockDoT As Integer = Spells.doFlameShockDoTModel(fsinfo(3), Variables.StoredSpellDmg, critDec)

        ' Counter for reporting progress back to the main thread.
        Dim repProgress As Integer = 0

        Do While currentTime <= modelFight
            If Variables.StoredHeroism = True And (HeroDebuff + 600) < currentTime Then HeroismActive = 0 ' Clear Heroism Debuff
            ' Shut down Heroism
            If Variables.StoredHeroism = True And (HeroismCastedTime + 40) < currentTime And HeroismActive = 1 Then
                HeroismActive = 2
                ' Set casting times back to non-Heroism values.
                LBCastTime = HastedLBCastTime
                FSGCDTime = HastedFSGCDTime
                LvBCastTime = HastedLvBCastTime
                CLCastTime = HastedCLCastTime
                UECastTime = HastedUECastTime
                FSDoTTime = HastedFSDoTTime
                FSDoTInterval = HastedFSDoTInterval
            End If
            ' Start up Heroism
            If Variables.StoredHeroism = True And HeroismActive = 0 Then
                HeroismActive = 1
                HeroismCastedTime = currentTime
                ' Set casting times to Heroism haste values.
                LBCastTime = HastedLBCastTimeHero
                FSGCDTime = HastedFSGCDTimeHero
                LvBCastTime = HastedLvBCastTimeHero
                CLCastTime = HastedCLCastTimeHero
                UECastTime = HastedUECastTimeHero
                FSDoTTime = HastedFSDoTTimeHero
                FSDoTInterval = HastedFSDoTIntervalHero
            End If

            ' Check for Unleash Element buff fading.
            If (UnleashActive = 1 And (UECastedTime + 15) <= currentTime) Then UnleashActive = 0

            ' Check for Flame Shock ticks.
            If FlameShockActive = 1 And (FlameShockTickTime + FSCastedTime + FSDoTInterval) <= currentTime Then
                numberofSpells(5) += 1
                spellDmg(5) += FlameShockDoT
                FlameShockTickTime += FSDoTInterval
            End If

            ' Check for Flame Shock fading off target.
            If FlameShockActive = 1 And (FSCastedTime + FSDoTTime) <= currentTime Then
                FlameShockActive = 0
                FlameShockTickTime = 0
            End If

            If (Busy <= currentTime) Then Busy = 0

            If (Busy = 0) Then  ' Only process casting events when the caster is free from other events. 
                If castFS = 1 And (FSCastedTime = 0 Or (FSCastedTime + FSDoTTime) <= currentTime) And FlameShockActive = 0 And (currentTime + FSGCDTime <= modelFight) Then
                    spellDmg(2) += FlameShockModelDamage
                    FSCastedTime = currentTime
                    shockcooldown = currentTime
                    numberofSpells(2) += 1
                    FlameShockActive = 1
                    Busy = FSGCDTime + Variables.StoredInstantLatency + currentTime
                ElseIf (castES = 1 And (shockcooldown <= currentTime) And (ESCastedTime + Variables.StoredRollingRamp) <= currentTime And (castFS = 0 Or FlameShockActive = 1 And (FSCastedTime + Variables.StoredFSDoTTime - 6) >= currentTime)) Then
                    spellDmg(7) += EarthShockModelDamage
                    spellDmg(8) += FulminationModelDamage
                    ESCastedTime = currentTime
                    shockcooldown = currentTime
                    numberofSpells(7) += 1
                    Busy = FSGCDTime + Variables.StoredInstantLatency + currentTime
                ElseIf castUE = 1 And UnleashActive = 0 And (castFS = 0 Or FlameShockActive = 1) And (LvBCastedTime = 0 Or (LvBCastedTime + UECastTime) <= currentTime) And (UECastedTime = 0 Or (UECastedTime + uecooldown) <= currentTime) Then
                    spellDmg(6) += UnleashElementsModelDamage
                    UECastedTime = currentTime
                    numberofSpells(6) += 1
                    Busy = UECastTime + Variables.StoredInstantLatency + currentTime
                ElseIf castLvB = 1 And (LvBCastedTime = 0 Or (LvBCastedTime + lvbcooldown) <= currentTime) And (FSCastedTime + Variables.StoredFSDoTTime - LvBCastTime) > currentTime And (currentTime + LvBCastTime <= modelFight) Then
                    Casting = LvBCastTime + currentTime
                    Busy = LvBCastTime + Variables.StoredLatency + currentTime
                    spellCast = 3
                ElseIf castCL = 1 And (CLCastedTime = 0 Or (CLCastedTime + clcooldown) <= currentTime) And (currentTime + CLCastTime <= modelFight) Then
                    Casting = CLCastTime + currentTime
                    Busy = CLCastTime + Variables.StoredLatency + currentTime
                    spellCast = 2
                ElseIf castLB = 1 And currentTime + LBCastTime <= modelFight Then
                    Casting = LBCastTime + currentTime
                    Busy = LBCastTime + Variables.StoredLatency + currentTime
                    spellCast = 1
                End If
            End If

            If (Casting <= currentTime) Then
                If (spellCast > 0) Then
                    If (spellCast = 1) Then
                        spellDmg(0) += LightningBoltModelDamage
                        numberofSpells(0) += 1
                    End If
                    If (spellCast = 2) Then
                        spellDmg(1) += ChainLightningModelDamage
                        CLCastedTime = currentTime
                        numberofSpells(1) += 1
                    End If
                    If (spellCast = 3) Then
                        spellDmg(3) += LavaBurstModelDamage
                        LvBCastedTime = currentTime
                        numberofSpells(3) += 1
                    End If
                    spellCast = 0
                End If
            End If

            ' Increment a counter to send time updates back to the main thread.
            If (repProgress = 1000 And worker IsNot Nothing) Then
                worker.ReportProgress(1, currentTime.ToString)
                repProgress = 0
            Else
                repProgress += 1
            End If

            currentTime += 0.001
        Loop

        ' Estimate deadtime.
        DeadTime = ((numberofSpells(0) + numberofSpells(1) + numberofSpells(3)) * Variables.StoredLatency) + ((numberofSpells(2) + numberofSpells(6)) * Variables.StoredInstantLatency)

        ' Account for Elemental Overload after the fact.
        Dim count As Decimal = Variables.StoredEleOverChance / 100
        spellDmg(4) = Round(((spellDmg(0) * 0.75) * count) + ((spellDmg(1) * 0.75) * count) + ((spellDmg(3) * 0.75) * count), 0)
        numberofSpells(4) = Round((numberofSpells(0) * count) + (numberofSpells(1) * count) + (numberofSpells(3) * count), 0)

        Variables.rawDamage.Add( _
                                currentTime & "," & critPcti & "," & hitPct & "," & modelFight & "," & _
                                spellDmg(0) & "," & numberofSpells(0) & "," & LBCastTime & "," & _
                                spellDmg(1) & "," & numberofSpells(1) & "," & CLCastTime & "," & _
                                spellDmg(2) & "," & numberofSpells(2) & "," & _
                                spellDmg(3) & "," & numberofSpells(3) & "," & LvBCastTime & "," & _
                                spellDmg(4) & "," & numberofSpells(4) & "," & _
                                spellDmg(5) & "," & numberofSpells(5) & "," & _
                                spellDmg(6) & "," & numberofSpells(6) & "," & UECastTime & "," & _
                                spellDmg(7) & "," & numberofSpells(7) & "," & _
                                spellDmg(8) & "," & _
                                DeadTime)
    End Sub

    Public Function RandomNumber(ByVal low As Integer, ByVal high As Integer) As Integer
        Static RandomNumGen As New System.Random
        Return RandomNumGen.Next(low, high + 1)
    End Function

    Public Function checkForCrit(ByVal critpct As Decimal, ByVal FS As Integer) As Integer
        ' Check for Winter's Chill
        critpct += Variables.TalentsHash.Item("Winters")

        Dim crithun As Integer = CInt(critpct * 100)
        Dim rolled As Integer = RandomNumber(1, 10000)
        Dim hascrit As Integer = 1
        If (rolled < crithun) Then hascrit = 2
        Return hascrit
    End Function

    Public Function getHastedCast(ByVal casttime, ByVal heroism, ByVal extraHaste) As Decimal
        ' Wrath of Air
        Dim woahaste As Decimal = 1
        If Variables.StoredWoACheck = 1 Then woahaste = 1.05
        ' Heroism 
        Dim hero As Decimal = 1
        If heroism = 1 Then hero = 1.3
        ' Haste Rating
        Dim hr As Decimal = 1
        If Variables.StoredHasteRate <> "0" Or extraHaste <> 0 Then
            Dim totalHaste = CInt(Variables.StoredHasteRate) + extraHaste
            hr = CDec(Round(totalHaste / Variables.Ratings.Item("Haste85"), 3))
            hr = (hr / 100) + 1
        End If
        ' WoA and Heroism stack.
        Dim percb As Decimal = (woahaste * hero)
        ' Get new cast time.
        Dim nct As Decimal = Round(casttime / hr / percb, 2, MidpointRounding.AwayFromZero)
        Return nct
    End Function

    Public Function getHitValue() As Decimal
        ' Add up +Hit values.
        Dim hitneeded As Decimal = 0
        Dim lvldiff As Integer = CInt(storedMobLevel.Remove(0, 1))
        Dim misspercent As Decimal = 0
        Dim localhit As Decimal = Variables.Ratings.Item("Hit85")
        If lvldiff = 0 Then
            hitneeded = localhit * 4
        ElseIf lvldiff = 1 Then
            hitneeded = localhit * 5
        ElseIf lvldiff = 2 Then
            hitneeded = localhit * 6
        ElseIf lvldiff = 3 Then
            hitneeded = localhit * 17
        End If
        If Variables.storedRace = "Draenei" Then hitneeded -= localhit
        hitneeded -= Variables.StoredHitRate
        If hitneeded > 0 Then misspercent = Round(hitneeded / localhit, 2) Else misspercent = 0
        ' Leftover is a decimal value of the chance to miss.
        Return misspercent
    End Function

    Public Function checkForHit(ByVal misspercent As Decimal) As Integer
        Dim hashit As Int16 = 0
        Dim missrange As Decimal = 100 - misspercent
        If missrange < 100 Then
            Static RandomNumGen As New System.Random
            Dim rolled As Decimal = Round(RandomNumGen.NextDouble, 4) * 100
            rolled = Round(RandomNumGen.NextDouble, 4) * 100
            If rolled > missrange Then hashit = 0 Else hashit = 1
        Else
            hashit = 1
        End If
        Return hashit
    End Function

    Public Sub checkClearcasting(ByRef CLEARCAST As Integer, ByRef clearcastingstate As Integer)
        If clearcastingstate = 1 Then
            CLEARCAST -= 1
            If CLEARCAST = 0 Then
                clearcastingstate = 0
                Variables.rawDamage.Add("7")
            End If
        End If
    End Sub

    Public Sub parseDamageResults()
        If Form1.doModel.Checked Then
            parseModelResults()
        Else
            parseSimulationResults()
        End If
    End Sub

    Public Sub parseSimulationResults()
        Try
            Dim totalLBDamage As Integer = 0
            Dim totalLODamage As Integer = 0
            Dim totalLvBDamage As Integer = 0
            Dim totalFSDamage As Integer = 0
            Dim totalCLDamage As Integer = 0
            Dim totalFSDoTDamage As Integer = 0
            Dim totalUEDamage As Integer = 0
            Dim totalESDamage As Integer = 0
            Dim totalFulDamage As Integer = 0

            Dim totalLBCrits As Integer = 0
            Dim totalLOCrits As Integer = 0
            Dim totalLvBCrits As Integer = 0
            Dim totalFSCrits As Integer = 0
            Dim totalCLCrits As Integer = 0
            Dim totalUECrits As Integer = 0
            Dim totalESCrits As Integer = 0
            Dim totalFulCrits As Integer = 0

            Dim totalLvBTimeSaved As Decimal = 0
            Dim totalLvB As Integer = 0

            Dim FulminationRampTime As Decimal = 0
            Dim totalFulmination As Integer = 0

            Dim output As String = ""
            Dim totalspells As Integer = 0
            Dim totalspellmiss As Integer = 0
            Dim totalclear As Integer = 0
            Dim i As Integer = 0
            For i = 0 To Variables.rawDamage.Count - 1
                Dim raw As String = Variables.rawDamage(i).ToString
                Dim rawarray() As String = raw.Split(CChar(","))
                ' 0 - Spell, 1 - Damage, 2 - Crit, 3 - ClearcastingState, 4 - Event timestamp
                If (rawarray(0) = "0") Then
                    ' Spell was Lightning Bolt.
                    totalspells += 1
                    totalLBDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalLBCrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Lightning Bolt: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Green
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "1") Then
                    ' Spell was Lava Burst.
                    totalspells += 1
                    totalLvB += 1
                    totalLvBDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalLvBCrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Lava Burst: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Orange
                        If (CDec(rawarray(2)) >= 2) Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "2") Then
                    ' Spell was Flame Shock
                    totalspells += 1
                    totalFSDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalFSCrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Flame Shock: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Orange
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "3") Then
                    ' Spell was Chain Lightning
                    totalspells += 1
                    totalCLDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.00] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalCLCrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Chain Lightning: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Green
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "4") Then
                    ' Spell was Elemental Overload
                    totalLODamage += CInt(rawarray(1))
                    If (rawarray(2) = "2") Then totalLOCrits += 1
                    Form1.TextBox1.AppendText("Elemental Overload: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Green
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "5") Then
                    ' Spell was FlameShock DoT tick
                    totalFSDoTDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    Form1.TextBox1.AppendText(ts & "Flame Shock DoT: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Orange
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        .AppendText(rawarray(1))
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "6") Then
                    ' Spell was Clearcasting Event Gain
                    With Form1.TextBox1
                        .SelectionColor = Color.Blue
                        .AppendText("       Clearcasting Proc!" & vbCrLf)
                    End With
                ElseIf (rawarray(0) = "7") Then
                    ' Spell was Clearcasting Event Fade
                    With Form1.TextBox1
                        .SelectionColor = Color.Red
                        .AppendText("       Clearcasting Faded" & vbCrLf)
                    End With
                ElseIf (rawarray(0) = "10") Then
                    ' Spell was Clearcasting Event Gain
                    With Form1.TextBox1
                        .SelectionColor = Color.Blue
                        .AppendText("       Clearcasting Refreshed" & vbCrLf)
                    End With
                ElseIf (rawarray(0) = "11") Then
                    ' Spell was Flame Shock Fade
                    With Form1.TextBox1
                        .SelectionColor = Color.DarkRed
                        .AppendText("       Flame Shock Faded" & vbCrLf)
                    End With
                ElseIf (rawarray(0) = "12") Then
                    ' Spell was Heroism Gain
                    With Form1.TextBox1
                        .SelectionColor = Color.Blue
                        .AppendText("       Heroism!" & vbCrLf)
                    End With
                ElseIf (rawarray(0) = "13") Then
                    ' Spell was Heroism Fade
                    With Form1.TextBox1
                        .SelectionColor = Color.Red
                        .AppendText("       Heroism Faded" & vbCrLf)
                    End With

                ElseIf (rawarray(0) = "14") Then
                    ' Spell was Unleash Elements.
                    totalspells += 1
                    totalUEDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalUECrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Unleash Elements: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Orange
                        If CDec(rawarray(2)) >= 2 Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If rawarray(1) > "0" Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "15") Then
                    ' Spell was Lava Surge
                    totalLvBTimeSaved += rawarray(1)
                    Dim waste As String = ""
                    If (rawarray(2) = "1") Then waste = " Wasted"
                    With Form1.TextBox1
                        .SelectionColor = Color.Blue
                        .AppendText("       Lava Surge" & waste & "! (" & rawarray(1) & " seconds trimmed)" & vbCrLf)
                    End With

                ElseIf (rawarray(0) = "16") Then
                    ' Spell was Earth Shock
                    totalspells += 1
                    totalESDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalESCrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Earth Shock: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Brown
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "17") Then
                    ' Spell was Fulmination
                    totalspells += 1
                    totalFulmination += 1
                    totalFulDamage += CInt(rawarray(1))
                    Dim timestamp As Decimal = rawarray(4)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    If (rawarray(4) <> "0") Then FulminationRampTime += rawarray(5)
                    If (rawarray(3) = "1") Then totalclear += 1
                    If (rawarray(2) = "2") Then totalFulCrits += 1
                    If (rawarray(1) = "0") Then totalspellmiss += 1
                    Form1.TextBox1.AppendText(ts & "Fulmination: ")
                    With Form1.TextBox1
                        .SelectionColor = Color.Green
                        If (rawarray(2) = "2") Then
                            .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Bold)
                        End If
                        If (rawarray(1) > "0") Then .AppendText(rawarray(1)) Else .AppendText("Woosh!")
                        .SelectionColor = Color.Black
                        .SelectionFont = New Font(Form1.TextBox1.SelectionFont, FontStyle.Regular)
                    End With
                    Form1.TextBox1.AppendText(vbCrLf)

                ElseIf (rawarray(0) = "98") Then
                    ' Spell was Rolling Thunder (Additional LS charge)
                    Dim charges As String = rawarray(1)
                    With Form1.TextBox1
                        .SelectionColor = Color.Blue
                        .AppendText("       Rolling Thunder! (" & charges & " charges stored)" & vbCrLf)
                    End With

                ElseIf (rawarray(0) = "99") Then
                    ' Spell cast start event.
                    Dim timestamp As Decimal = rawarray(2)
                    Dim ts As String = timestamp.ToString("[####0.000] ", Globalization.CultureInfo.InvariantCulture)
                    Form1.TextBox1.AppendText(ts & Variables.charName & " begins to cast " & rawarray(1) & vbCrLf)
                End If
            Next

            ' DPS
            Dim totaltime As Decimal = CDec(CDbl(Form1.FightLength.Text) * 60)
            Form1.DPSforCycle.Text = CStr(System.Math.Round((totalLBDamage + totalLODamage + totalLvBDamage + totalCLDamage + totalFSDamage + totalFSDoTDamage + totalUEDamage + totalESDamage + totalFulDamage) / totaltime, 2))
            Form1.EffectiveCritRate.Text = System.Math.Round(((totalLBCrits + totalLvBCrits + totalLOCrits + totalCLCrits + totalFSCrits + totalUECrits + totalESCrits + totalFulCrits) / totalspells) * 100, 2) & "%"
            Form1.EffectiveHitRate.Text = System.Math.Round(((totalspells - totalspellmiss) / totalspells) * 100, 2) & "%"
            Form1.EffectiveMasteryRate.Text = Variables.StoredEleOverChance & "%"

            Dim clearperc As Decimal = Round(totalclear / totalspells, 2) * 100
            Form1.TextBox1.AppendText(vbCrLf & "Total Spells: " & totalspells & vbCrLf)
            Form1.TextBox1.AppendText("Total spells under the effects of Clearcasting: " & totalclear & " (" & clearperc & "%)" & vbCrLf)
            If (totalLvBTimeSaved <> "0") Then
                Dim times As Decimal = Round(totalLvBTimeSaved / totalLvB, 3)
                Form1.TextBox1.AppendText("Average time trimmed from LvB cooldown: " & times & " seconds" & vbCrLf)
            End If
            If (FulminationRampTime <> "0") Then
                Dim fultime As Decimal = Round(FulminationRampTime / totalFulmination, 3)
                Form1.TextBox1.AppendText("Average time ramping up Lightning Shield charges: " & fultime & " seconds" & vbCrLf)
            End If
        Catch ex As Exception
            Form1.TextBox1.AppendText("Error: " & ex.Message)
        End Try

    End Sub

    Public Sub parseModelResults()
        Dim raf() As String = Split(Variables.rawDamage(0).ToString, ",")

        Dim totalDamage As Integer = CInt(raf(4)) + CInt(raf(7)) + CInt(raf(10)) + CInt(raf(12)) + CInt(raf(15)) + CInt(raf(17)) + CInt(raf(19)) + CInt(raf(22)) + CInt(raf(24))

        Form1.TextBox1.AppendText("Total damage done: " & totalDamage & vbCrLf)
        Form1.TextBox1.AppendText("Actual time spent: " & raf(0) & " seconds" & vbCrLf)
        Form1.TextBox1.AppendText("Time spent doing nothing: " & raf(25) & " seconds" & vbCrLf & vbCrLf)

        If raf(4) <> "0" Then
            Dim LBdmg As Double = Round((CInt(raf(4)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Lightning Bolt damage done: " _
                                      & raf(4) & " - " & raf(5) & " bolts fired (" _
                                      & CDbl(raf(4)) / CDbl(raf(5)) & " dmg avg - " & raf(6) & " cast time) (" _
                                      & LBdmg & "% of total damage)" & vbCrLf)
        End If
        If raf(12) <> "0" Then
            Dim LvBdmg As Double = Round((CInt(raf(12)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Lava Burst damage done: " _
                                      & raf(12) & " - " & raf(13) & " bolts fired (" _
                                      & CDbl(raf(12)) / CDbl(raf(13)) & " dmg avg - " & raf(14) & " cast time) (" _
                                      & LvBdmg & "% of total damage)" & vbCrLf)
        End If
        If raf(7) <> "0" Then
            Dim CLdmg As Double = Round((CInt(raf(7)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Chain Lightning damage done: " _
                                      & raf(7) & " - " & raf(8) & " bolts fired (" _
                                      & CDbl(raf(7)) / CDbl(raf(8)) & " dmg avg - " & raf(9) & " cast time) (" _
                                      & CLdmg & "% of total damage)" & vbCrLf)
        End If
        If raf(10) <> "0" Then
            Dim FSdmg As Double = Round((CInt(raf(10)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Flame Shock damage done: " _
                                      & raf(10) & " - " & raf(11) & " applications (" _
                                      & CDbl(raf(10)) / CDbl(raf(11)) & " dmg avg) (" _
                                      & FSdmg & "% of total damage)" & vbCrLf)
        End If
        If (raf(22) <> "0") Then
            Dim ESdmg As Double = Round((CInt(raf(22)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Earth Shock damage done: " _
                                      & raf(22) & " - " & raf(23) & " casts (" _
                                      & CDbl(raf(22)) / CDbl(raf(23)) & " dmg avg) (" _
                                      & ESdmg & "% of total damage)" & vbCrLf)
        End If
        If (raf(24) <> "0") Then
            Dim FulDmg As Double = Round((CInt(raf(24)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Fulmination damage done: " _
                                      & raf(24) & " - " & raf(23) & " casts (" _
                                      & CDbl(raf(24)) / CDbl(raf(23)) & " dmg avg) (" _
                                      & FulDmg & "% of total damage)" & vbCrLf)
        End If
        If raf(15) <> "0" Then
            Dim LOdmg As Double = Round((CInt(raf(15)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Elemental Overload damage done (estimated): " _
                                      & raf(15) & " - " & raf(16) & " bolts fired (" _
                                      & Round(CDbl(raf(15)) / CDbl(raf(16)), 0) & " dmg avg) (" _
                                      & LOdmg & "% of total damage)" & vbCrLf)
        End If
        If raf(19) <> "0" Then
            Dim UEdmg As Double = Round((CInt(raf(19)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Unleash Elements damage done: " _
                                      & raf(19) & " - " & raf(20) & " casts (" _
                                      & CDbl(raf(19)) / CDbl(raf(20)) & " dmg avg - " & raf(21) & " cast time) (" _
                                      & UEdmg & "% of total damage)" & vbCrLf)
        End If
        If raf(17) <> "0" Then
            Dim FSDdmg As Double = Round((CInt(raf(17)) / totalDamage) * 100, 2)
            Form1.TextBox1.AppendText("Flame Shock DoT damage done: " _
                                      & raf(17) & " - " & raf(18) & " ticks (" _
                                      & Round(CDbl(raf(17)) / CDbl(raf(18)), 0) & " dmg avg) (" _
                                      & FSDdmg & "% of total damage)" & vbCrLf)
        End If

        Form1.TextBox1.AppendText(vbCrLf)
        Form1.DPSforCycle.Text = CStr(Round(totalDamage / CDbl(raf(0))))
        Form1.EffectiveCritRate.Text = raf(1) & "%"
        Form1.EffectiveHitRate.Text = CDbl(raf(2)) * 100 & "%"
        Form1.EffectiveMasteryRate.Text = Variables.StoredEleOverChance & "%"
    End Sub

    Public Function parseTenResults()
        Dim result As String = ""
        Dim i As Integer = 0
        Dim raf() As String = Split(Variables.rawDamage(i).ToString, ",")
        Dim totalDamage As Integer = CInt(raf(4)) + CInt(raf(7)) + CInt(raf(10)) + CInt(raf(12)) + CInt(raf(15)) + CInt(raf(17)) + CInt(raf(19)) + CInt(raf(22)) + CInt(raf(24))
        result = CStr(Round(totalDamage / CDbl(raf(0))))
        Return result
    End Function

    Public Sub populateVariables()
        Variables.Coefficients.Add("LB", 0.914)
        Variables.Coefficients.Add("CL", 0.771)
        Variables.Coefficients.Add("LvB", 0.771)
        Variables.Coefficients.Add("FS", 0.214)
        Variables.Coefficients.Add("ES", 0.3858)
        Variables.Coefficients.Add("FSDoT", 0.1)
        Variables.Coefficients.Add("UE", 0.429)           ' Hylas from TotemSpot came up with this number
        Variables.Coefficients.Add("Ful", 0.267)

        Variables.Ratings.Add("Haste85", 128.05)         ' 127.5
        Variables.Ratings.Add("Hit85", 102.446)          ' Most of these numbers are from Whitetooth (I had 102.523)
        Variables.Ratings.Add("Mastery85", 179.28)       ' Someone said 212.5, I see 179 (WT says add .28)
        ' +Crit, #Crit=1Int
        Variables.Ratings.Add("Crit85", "179.28,0.00163")   ' Do not have the lvl 85 conversion of int to crit yet (A good one)
        ' Base Int
        Variables.Intellect.Add("Draenei", "139")           ' Values MAY be wrong (except Draenei)
        Variables.Intellect.Add("Dwarf", "138")             ' Don't have Tauren yet.
        Variables.Intellect.Add("Goblin", "143")            ' Values are estimated assuming people who supplied them had Mail Specialization (Except Orc and Troll)
        Variables.Intellect.Add("Orc", "136")
        Variables.Intellect.Add("Tauren", "139")
        Variables.Intellect.Add("Troll", "135")

        ' Spells - Min, Max, Avg, DoT (damage per tick)
        Variables.Spells.Add("LB85", "719,821,770")
        Variables.Spells.Add("CL85", "1020,1164,1092")
        Variables.Spells.Add("LvB85", "1394,1778,1586")
        Variables.Spells.Add("FS85", "531,531,531,143")
        Variables.Spells.Add("FLT85", "748")
        Variables.Spells.Add("UE85", "1023,1211,1117")
        Variables.Spells.Add("ES85", "907,955,931")
        Variables.Spells.Add("Ful85", "390,390,390") ' Single base charge of Lightning Shield damage.

        ' Totems
        Variables.TotemHash.Add("WOA", "5")

        ' Talents
        Variables.TalentsHash.Add("Concuss", "1.0")
        Variables.TalentsHash.Add("CallFla", "0.0")
        Variables.TalentsHash.Add("ElePrec", "0")
        Variables.TalentsHash.Add("LavaFlo", "0.0")
        Variables.TalentsHash.Add("CurseOE", "0.0")
        Variables.TalentsHash.Add("Winters", "0")
        Variables.TalentsHash.Add("ImpFaFi", "0")
    End Sub

    Public Sub moveToStorageChar()
        If (Form1.CharSelect.Text <> "") Then Variables.charName = Form1.CharSelect.Text Else Variables.charName = "Shaman"
        If (Form1.Spells_LB.Checked) Then Variables.SpellsToCast("LB") = 1 Else Variables.SpellsToCast("LB") = 0
        If (Form1.Spells_CL.Checked) Then Variables.SpellsToCast("CL") = 1 Else Variables.SpellsToCast("CL") = 0
        If (Form1.Spells_FS.Checked) Then Variables.SpellsToCast("FS") = 1 Else Variables.SpellsToCast("FS") = 0
        If (Form1.Spells_LvB.Checked) Then Variables.SpellsToCast("LvB") = 1 Else Variables.SpellsToCast("LvB") = 0
        If (Form1.Spells_UE.Checked) Then Variables.SpellsToCast("UE") = 1 Else Variables.SpellsToCast("UE") = 0
        If (Form1.Spells_ES.Checked) Then Variables.SpellsToCast("ES") = 1 Else Variables.SpellsToCast("ES") = 0
        Variables.StoredFightLength = CDec(Form1.FightLength.Text)
        Variables.StoredMobLevel = Form1.MobLevel.Text
        Variables.StoredRace = Form1.RaceSelect.Text
        Variables.StoredClearcastUp = CDec(Form1.ClearcastUptime.Text)
        Variables.StoredLSBenefit = CDec(Form1.LavaSurgeBenefit.Text)
        Variables.StoredFulmCharge = CInt(Form1.FulmCharge.Text)
        Variables.StoredRollingRamp = CDec(Form1.RollingThunderRamp.Text)
        Variables.StoredLatency = CDec(Form1.Latency.Text) / 1000
        Variables.StoredInstantLatency = CDec(Form1.instaLatency.Text) / 1000
    End Sub

    Public Sub moveToStorageStats()
        Variables.StoredSpellDmg = CInt(Form1.SpellPower.Text)
        Variables.StoredCritPerc = CDec(Form1.CritPercent.Text)
        Variables.StoredHitRate = CDec(Form1.HitRating.Text)
        Variables.StoredHasteRate = CDec(Form1.HasteRating.Text)
        Variables.StoredMastRate = CDec(Form1.MasteryRating.Text)
    End Sub

    ' Convert Slot ID into the Slot Name
    Public Function getSlotName(ByVal id As String) As String
        Dim result As String = id
        Select Case id
            Case "1"
                result = "Head"
            Case "2"
                result = "Neck"
            Case "3"
                result = "Shoulders"
            Case "4"
                result = "Shirt"
            Case "5"
                result = "Chest"
            Case "6"
                result = "Waist"
            Case "7"
                result = "Legs"
            Case "8"
                result = "Feet"
            Case "9"
                result = "Wrist"
            Case "10"
                result = "Hands"
            Case "11"
                result = "Finger"
            Case "12"
                result = "Trinket"
            Case "13"
                result = "OneHanded"
            Case "14"
                result = "Shield"
            Case "16"
                result = "Back"
            Case "17"
                result = "TwoHanded"
            Case "19"
                result = "Tabard"
            Case "21"
                result = "MainHand"
            Case "23"
                result = "OffHand"
            Case "28"
                result = "Relic"
        End Select
        Return result
    End Function

    ' Convert Slot Name into the Slot ID
    Public Function getSlotID(ByVal slot As String) As String
        Dim result As String = slot
        Select Case slot
            Case "Head"
                result = "1"
            Case "Neck"
                result = "2"
            Case "Shoulders"
                result = "3"
            Case "Shoulder"
                result = "3"
            Case "Shirt"
                result = "4"
            Case "Chest"
                result = "5"
            Case "Waist"
                result = "6"
            Case "Legs"
                result = "7"
            Case "Feet"
                result = "8"
            Case "Wrist"
                result = "9"
            Case "Hands"
                result = "10"
            Case "Finger"
                result = "11"
            Case "Trinket"
                result = "12"
            Case "OneHanded"
                result = "13"
            Case "Shield"
                result = "14"
            Case "Back"
                result = "16"
            Case "TwoHanded"
                result = "17"
            Case "Tabard"
                result = "19"
            Case "MainHand"
                result = "21"
            Case "OffHand"
                result = "23"
            Case "Relic"
                result = "28"
        End Select
        Return result
    End Function

    ' Check for checks!
    Public Function checkCheck(ByVal element As Boolean) As String
        Dim result As String = "0"
        If (element = True) Then
            result = "1"
        Else
            result = "0"
        End If
        Return result
    End Function
End Module

'Notes
'0 lbdmg
'1 lvbdmg
'2 fsdmg
'3 cldmg
'4 critPcti
'5 hitPct
'6 modelFight
'7 numberofLBs
'8 numberofLvBs
'9 numberofFSs
'10 numberofCLs
'11 currentTime
'12 HastedLBCastTime
'13 HastedCLCastTime
'14 HastedLvBCastTime

' Model run Array
' 00 = Time Spent
' 01 = Crit Percent
' 02 = Hit Percent
' 03 = Fight Length 
' 04 = LB total damage
' 05 = LB total casts
' 06 = LB cast time
' 07 = CL total damage
' 08 = CL total casts
' 09 = CL cast time
' 10 = FS total damage
' 11 = FS total casts
' 12 = LvB total damage
' 13 = LvB total casts
' 14 = LvB cast time
' 15 = EO total damage
' 16 = EO total casts
' 17 = FSDoT total damage
' 18 = FSDoT total ticks
' 19 = UE total damage
' 20 = UE total casts
' 21 = UE cast time
' 22 = ES total damage
' 23 = ES total casts
' 24 = Ful total damage
' 25 = Time spent doing nothing
