﻿Imports System.Math

Module Spells
    ' Simulation spells
    Public Sub doLightningBolt(ByVal misspct, ByVal overload, ByVal currenttime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef clearcastingstart, ByVal eleoathbonus, ByVal splo, ByVal sphi, ByVal extraSP)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If hashit = 1 Then
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            Dim lbdmg As Integer = basedmg + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("LB"))
            lbdmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            lbdmg *= Variables.TalentsHash.Item("Concuss") + Variables.StoredGoLBCheck
            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 0)
            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                critbonus *= 2
                Dim critBonusDmg As Decimal = lbdmg * critbonus
                lbdmg += critBonusDmg
            End If

            lbdmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then lbdmg *= eleoathbonus

            If (overload = 4) Then lbdmg *= 0.75

            Variables.rawDamage.Add(overload & "," & lbdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currenttime)
            If (hascrit = 2 And overload <> 4) Then
                If (clearcastingstate = 0) Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
                clearcastingstart = currenttime
            Else
                If (overload <> 4) Then checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            If (overload <> 4) Then checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add(overload & ",0,0," & clearcastingstate & "," & currenttime)
        End If
    End Sub

    Public Sub doLavaBurst(ByVal misspct, ByVal overload, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef clearcastingstart, ByVal FlameShockActive, ByVal eleoathbonus, ByRef UnleashActive, ByVal splo, ByVal sphi)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If (hashit = 1) Then
            Dim hascrit As Decimal = 1
            If (FlameShockActive = 1) Then
                hascrit = 2
            Else
                hascrit = Other.checkForCrit(Variables.StoredCritPerc, 1)
            End If

            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            Dim lvbdmg As Integer = basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))
            lvbdmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            lvbdmg *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla") + Variables.StoredGoLvBCheck

            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If (Variables.StoredMetaCrit = 1) Then critbonus = 0.545
                critbonus *= 2 + Variables.TalentsHash.Item("LavaFlo")
                Dim critBonusDmg As Decimal = lvbdmg * critbonus
                lvbdmg += critBonusDmg
            End If

            lvbdmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then lvbdmg *= eleoathbonus

            ' Consider Unleash Elements bonus to damage.  Unsure where this goes yet.  
            If (UnleashActive = 1 And overload <> 4) Then
                lvbdmg *= 1.3
                UnleashActive = 0
            End If

            If (overload = 4) Then lvbdmg *= 0.75

            Variables.rawDamage.Add(overload & "," & lvbdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            If (hascrit = 2 And overload <> 4) Then
                If (clearcastingstate = 0) Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
                clearcastingstart = currentTime
            Else
                checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add("1,0,0," & clearcastingstate & "," & currentTime)
        End If
    End Sub

    Public Sub doFlameShock(ByVal misspct, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef clearcastingstart, ByRef FlameShockActive, ByVal eleoathbonus, ByVal splo, ByVal sphi)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If (hashit = 1) Then
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            Dim fsdmg As Integer = basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("FS"))
            fsdmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            fsdmg *= Variables.TalentsHash.Item("Concuss")
            'Dim fsdmg As Integer = (basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("FS"))) * (Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("ElePrec"))

            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 1)
            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                critbonus *= 2
                Dim critBonusDmg As Decimal = fsdmg * critbonus
                fsdmg += critBonusDmg
            End If

            fsdmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then fsdmg *= eleoathbonus

            Variables.rawDamage.Add("2," & fsdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            FlameShockActive = 1
            If (hascrit = 2) Then
                If (clearcastingstate = 0) Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
                clearcastingstart = currentTime
            Else
                Other.checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            Other.checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add("2,0,0," & clearcastingstate & "," & currentTime)
            FlameShockActive = 0
        End If
    End Sub

    Public Sub doChainLightning(ByVal misspct, ByVal overload, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef clearcastingstart, ByVal eleoathbonus, ByVal splo, ByVal sphi, ByVal extraSP)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If (hashit = 1) Then
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            Dim cldmg As Integer = basedmg + (Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("CL")
            cldmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            cldmg *= Variables.TalentsHash.Item("Concuss")
            'Dim cldmg As Integer = (basedmg + ((Variables.StoredSpellDmg + extraSP) * Variables.Coefficients.Item("CL"))) * (Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("ElePrec"))

            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 0)
            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If (Variables.StoredMetaCrit = 1) Then critbonus = 0.545
                critbonus *= 2
                Dim critBonusDmg As Decimal = cldmg * critbonus
                cldmg += critBonusDmg
            End If

            cldmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then cldmg *= eleoathbonus

            If (overload = 4) Then cldmg *= 0.75

            Variables.rawDamage.Add(overload & "," & cldmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            If (hascrit = 2) Then
                If (clearcastingstate = 0) Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
                clearcastingstart = currentTime
            Else
                If (overload <> 4) Then checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            If (overload <> 4) Then checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add(overload & ",0,0," & clearcastingstate & "," & currentTime)
        End If
    End Sub

    Public Function doFlameShockDoT(ByVal fsdotav, ByVal dmgbonus, ByVal CCActive, ByVal eleoathbonus) As String()
        Dim fscur As Integer = fsdotav + (dmgbonus * Variables.Coefficients.Item("FSDoT"))
        fscur *= 1 + Variables.TalentsHash.Item("ElePrec")
        fscur *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("LavaDoT")
        If CCActive = 1 Then fscur *= eleoathbonus

        Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 1)
        If (hascrit = 2) Then
            Dim critbonus As Decimal = 0.5
            If (Variables.StoredMetaCrit = 1) Then critbonus = 0.545
            critbonus *= 2
            Dim critBonusDmg As Decimal = fscur * critbonus
            fscur += critBonusDmg
        End If
        Dim result() As String = {fscur, hascrit}
        Return result
    End Function

    Public Sub doUnleashElements(ByVal misspct, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef UnleashActive, ByVal eleoathbonus, ByVal splo, ByVal sphi)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If (hashit = 1) Then
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            Dim uedmg As Integer = basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("UE"))
            uedmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            'Dim uedmg As Integer = (basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("UE"))) * (1 + Variables.TalentsHash.Item("ElePrec"))

            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 1)
            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If (Variables.StoredMetaCrit = 1) Then critbonus = 0.545
                critbonus *= 2
                Dim critBonusDmg As Decimal = uedmg * critbonus
                uedmg += critBonusDmg
            End If

            uedmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then uedmg *= eleoathbonus

            Variables.rawDamage.Add("14," & uedmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)
            ' Cannot cause Clearcasting on crit, but will consume a charge of Clearcasting when cast.
            Other.checkClearcasting(CLEARCAST, clearcastingstate)

            ' Set the bonus to the next fire spell.
            UnleashActive = 1
        Else
            Other.checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add("2,0,0," & clearcastingstate & "," & currentTime)
        End If
    End Sub

    Public Sub doEarthShock(ByVal misspct, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef clearcastingstart, ByVal eleoathbonus, ByVal splo, ByVal sphi)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If (hashit = 1) Then
            Dim basedmg As Integer = Other.RandomNumber(splo, sphi)
            Dim esdmg As Integer = basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("ES"))
            esdmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            esdmg *= Variables.TalentsHash.Item("Concuss")

            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 1)
            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                critbonus *= 2
                Dim critBonusDmg As Decimal = esdmg * critbonus
                esdmg += critBonusDmg
            End If

            esdmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then esdmg *= eleoathbonus

            Variables.rawDamage.Add("16," & esdmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime)

            If (hascrit = 2) Then
                If (clearcastingstate = 0) Then rawDamage.Add("6") Else rawDamage.Add("10")
                CLEARCAST = 2
                clearcastingstate = 1
                clearcastingstart = currentTime
            Else
                Other.checkClearcasting(CLEARCAST, clearcastingstate)
            End If
        Else
            Other.checkClearcasting(CLEARCAST, clearcastingstate)
            Variables.rawDamage.Add("16,0,0," & clearcastingstate & "," & currentTime)
        End If
    End Sub

    Public Sub doFulmination(ByVal misspct, ByVal currentTime, ByRef CLEARCAST, ByRef clearcastingstate, ByRef clearcastingstart, ByVal eleoathbonus, ByVal splo, ByVal sphi, ByVal lscharges, ByVal ChargeBuildTime)
        Dim hashit As Int16 = Other.checkForHit(misspct)
        If (hashit = 1) Then
            'Dim basedmg As Integer = Other.RandomNumber(splo, sphi) 
            Dim basedmg As Integer = splo
            Dim fuldmg As Integer = basedmg + (Variables.StoredSpellDmg * Variables.Coefficients.Item("Ful"))
            fuldmg *= 1 + Variables.TalentsHash.Item("ElePrec")
            fuldmg *= 1.15 ' Improved Shields
            fuldmg *= lscharges - 3

            Dim hascrit As Decimal = Other.checkForCrit(Variables.StoredCritPerc, 1)
            If (hascrit = 2) Then
                Dim critbonus As Decimal = 0.5
                If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
                critbonus *= 2
                Dim critBonusDmg As Decimal = fuldmg * critbonus
                fuldmg += critBonusDmg
            End If

            fuldmg *= Variables.TalentsHash.Item("CurseOE")
            If (clearcastingstate = 1) Then fuldmg *= eleoathbonus
            Variables.rawDamage.Add("17," & fuldmg.ToString & "," & hascrit.ToString & "," & clearcastingstate & "," & currentTime & "," & ChargeBuildTime)
        Else
            Variables.rawDamage.Add("17,0,0," & clearcastingstate & "," & currentTime & "," & ChargeBuildTime)
        End If
    End Sub

    Public Sub doRollingThunder(ByRef LSCharges, ByRef ChargeBuildTime, ByVal currentTime, ByVal FulminationCastTime)
        Dim rtproc As Integer = RandomNumber(1, 100)
        If (rtproc <= Variables.TalentsHash.Item("RollingThunder")) Then
            If (LSCharges < 9) Then
                LSCharges += 1
                If (LSCharges = Variables.StoredFulmCharge) Then ChargeBuildTime = currentTime - FulminationCastTime
            End If
            Variables.rawDamage.Add("98," & LSCharges & ",")
        End If
    End Sub


    ' Model Spells
    Public Function doLavaBurstModel(ByVal lvbav, ByVal critdec, ByVal hitpct, ByVal dmgbonus)
        Dim lvbcur As Integer = lvbav + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))
        lvbcur *= 1 + Variables.TalentsHash.Item("ElePrec")
        lvbcur *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla") + Variables.StoredGoLvBCheck
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= 2 + Variables.TalentsHash.Item("LavaFlo")
        Dim critBonusDmg As Decimal = lvbcur * critbonus
        critBonusDmg *= hitpct
        lvbcur += critBonusDmg
        lvbcur *= Variables.TalentsHash.Item("CurseOE")
        Dim uebonus As Decimal = 0.3 * hitpct
        lvbcur *= 1 + (uebonus * 0.5)
        lvbcur *= hitpct
        lvbcur = Round(lvbcur * dmgbonus, 0)
        Return lvbcur
    End Function

    Public Function doFlameShockDoTModel(ByVal fsdotav, ByVal dmgbonus, ByVal critdec)
        Dim fscur As Integer = fsdotav + (dmgbonus * Variables.Coefficients.Item("FSDoT"))
        fscur *= 1 + Variables.TalentsHash.Item("ElePrec")
        fscur *= Variables.TalentsHash.Item("LavaDoT") + Variables.TalentsHash.Item("Concuss")
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= 2
        Dim critBonusDmg As Decimal = fscur * critbonus
        critBonusDmg *= critdec - 1
        fscur += critBonusDmg
        Return fscur
    End Function

    Public Function doGenericSpellModel(ByVal dmgav As Integer, ByVal critdec As Decimal, ByVal hitpct As Decimal, ByVal dmgbonus As Integer, ByVal Spell As String, ByVal useConcussion As Integer)
        Dim dmgcur As Integer = dmgav + Variables.StoredSpellDmg * Variables.Coefficients.Item(Spell)
        dmgcur *= 1 + Variables.TalentsHash.Item("ElePrec")

        If (useConcussion = 1) Then
            If (Spell = "LB") Then
                dmgcur *= Variables.TalentsHash.Item("Concuss") + Variables.StoredGoLBCheck
            Else
                dmgcur *= Variables.TalentsHash.Item("Concuss")
            End If
        End If

        If (Spell = "Ful") Then
            dmgcur *= 1.15 ' Improved Shields
            dmgcur *= Variables.StoredFulmCharge ' LS charges
        End If

        Dim critbonus As Decimal = 0.5
        If (Variables.StoredMetaCrit = 1) Then critbonus = 0.545
        critbonus *= 2
        Dim critBonusDmg As Decimal = dmgcur * critbonus
        critBonusDmg *= critdec - 1
        dmgcur += critBonusDmg
        dmgcur *= Variables.TalentsHash.Item("CurseOE")
        dmgcur *= hitpct
        dmgcur = Round(dmgcur * dmgbonus, 0)
        Return dmgcur
    End Function

    ' Statistic Spells
    Public Function doLightningBoltStat()
        Dim result As String = ""
        Dim lbinfo() As String = Split(Variables.Spells.Item("LB85"), ",")

        Dim lbdmglo As Integer = ((lbinfo(0) + ((Variables.StoredSpellDmg) * Variables.Coefficients.Item("LB"))))
        Dim lbdmghi As Integer = ((lbinfo(1) + ((Variables.StoredSpellDmg) * Variables.Coefficients.Item("LB"))))

        lbdmglo *= 1 + Variables.TalentsHash.Item("ElePrec")
        lbdmglo *= Variables.TalentsHash.Item("Concuss") + Variables.StoredGoLBCheck
        lbdmghi *= 1 + Variables.TalentsHash.Item("ElePrec")
        lbdmghi *= Variables.TalentsHash.Item("Concuss") + Variables.StoredGoLBCheck

        ' Crit bonus damage
        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= 2
        Dim lbcritlo As Decimal = Round((lbdmglo * critbonus) + lbdmglo, 0)
        Dim lbcrithi As Decimal = Round((lbdmghi * critbonus) + lbdmghi, 0)

        ' Spell damage debuff
        lbdmglo *= Variables.TalentsHash.Item("CurseOE")
        lbdmghi *= Variables.TalentsHash.Item("CurseOE")
        lbcritlo *= Variables.TalentsHash.Item("CurseOE")
        lbcrithi *= Variables.TalentsHash.Item("CurseOE")

        ' Now assume the player has Elemental Oath
        Dim eleoathbonus As Decimal = 1.1

        ' Elemental Oath bonus Damage while Clearcasting active.
        Dim lbcclo As Integer = lbdmglo * eleoathbonus
        Dim lbcchi As Integer = lbdmghi * eleoathbonus
        Dim lbccclo As Integer = lbcritlo * eleoathbonus
        Dim lbccchi As Integer = lbcrithi * eleoathbonus

        result = "Lightning Bolt Damage: " & lbdmglo & " - " & lbdmghi & " (With CC up: " & lbcclo & " - " & lbcchi & ")" & vbCrLf
        result &= "Lightning Bolt Crit Damage: " & lbcritlo & " - " & lbcrithi & " (With CC up: " & lbccclo & " - " & lbccchi & ")" & vbCrLf
        Return result
    End Function

    Function doLavaBurstStat()
        Dim result As String = ""
        Dim lvbinfo() As String = Split(Variables.Spells.Item("LvB85"), ",")

        Dim lvbdmglo As Integer = lvbinfo(0) + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))
        Dim lvbdmghi As Integer = lvbinfo(1) + (Variables.StoredSpellDmg * Variables.Coefficients.Item("LvB"))

        lvbdmglo *= 1 + Variables.TalentsHash.Item("ElePrec")
        lvbdmglo *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla") + Variables.StoredGoLvBCheck
        lvbdmghi *= 1 + Variables.TalentsHash.Item("ElePrec")
        lvbdmghi *= Variables.TalentsHash.Item("Concuss") + Variables.TalentsHash.Item("CallFla") + Variables.StoredGoLvBCheck

        Dim critbonus As Decimal = 0.5
        If Variables.StoredMetaCrit = 1 Then critbonus = 0.545
        critbonus *= 2 + Variables.TalentsHash.Item("LavaFlo")
        Dim lvbcritlo As Decimal = Round((lvbdmglo * critbonus) + lvbdmglo, 0)
        Dim lvbcrithi As Decimal = Round((lvbdmghi * critbonus) + lvbdmghi, 0)

        lvbdmglo *= Variables.TalentsHash.Item("CurseOE")
        lvbdmghi *= Variables.TalentsHash.Item("CurseOE")
        lvbcritlo *= Variables.TalentsHash.Item("CurseOE")
        lvbcrithi *= Variables.TalentsHash.Item("CurseOE")

        Dim eleoathbonus As Decimal = 1.1
        Dim lvbcclo As Integer = lvbdmglo * eleoathbonus
        Dim lvbcchi As Integer = lvbdmghi * eleoathbonus
        Dim lvbccclo As Integer = lvbcritlo * eleoathbonus
        Dim lvbccchi As Integer = lvbcrithi * eleoathbonus

        result = "Lava Burst Damage: " & lvbdmglo & " - " & lvbdmghi & " (With CC up: " & lvbcclo & " - " & lvbcchi & ")" & vbCrLf
        result &= "Lava Burst Crit Damage: " & lvbcritlo & " - " & lvbcrithi & " (With CC up: " & lvbccclo & " - " & lvbccchi & ")" & vbCrLf
        Return result
    End Function
End Module
