﻿Public Class ItemImporter_Gear

    Private Sub GearImportButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GearImportButton.Click
        If ItemTextBox.Text <> "" Then
            Dim items() As String = Split(ItemTextBox.Text, ";")
            Dim item As String = ""
            For Each item In items
                If item <> "" Then
                    Dim result As String = Armory.CheckItemDB(item, "0")
                    Dim sl() As String = Split(result, ";")
                    If UBound(sl) > 0 Then
                        If sl(0) = "1" Then
                            If Variables.HeadArray.Contains(sl(1)) Then Variables.HeadArray.Remove(sl(1))
                            Variables.HeadArray.Add(sl(1), result)
                            Form1.HeadCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "2" Then
                            If Variables.NeckArray.Contains(sl(1)) Then Variables.NeckArray.Remove(sl(1))
                            Variables.NeckArray.Add(sl(1), result)
                            Form1.NeckCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "3" Then
                            If Variables.ShoulderArray.Contains(sl(1)) Then Variables.ShoulderArray.Remove(sl(1))
                            Variables.ShoulderArray.Add(sl(1), result)
                            Form1.ShouldersCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "5" Then ' Also slot 20, changed to 5 on import
                            If Variables.ChestArray.Contains(sl(1)) Then Variables.ChestArray.Remove(sl(1))
                            Variables.ChestArray.Add(sl(1), result)
                            Form1.ChestCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "6" Then
                            If Variables.WaistArray.Contains(sl(1)) Then Variables.WaistArray.Remove(sl(1))
                            Variables.WaistArray.Add(sl(1), result)
                            Form1.WaistCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "7" Then
                            If Variables.LegsArray.Contains(sl(1)) Then Variables.LegsArray.Remove(sl(1))
                            Variables.LegsArray.Add(sl(1), result)
                            Form1.LegsCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "8" Then
                            If Variables.FeetArray.Contains(sl(1)) Then Variables.FeetArray.Remove(sl(1))
                            Variables.FeetArray.Add(sl(1), result)
                            Form1.FeetCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "9" Then
                            If Variables.WristArray.Contains(sl(1)) Then Variables.WristArray.Remove(sl(1))
                            Variables.WristArray.Add(sl(1), result)
                            Form1.WristCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "10" Then
                            If Variables.HandsArray.Contains(sl(1)) Then Variables.HandsArray.Remove(sl(1))
                            Variables.HandsArray.Add(sl(1), result)
                            Form1.HandsCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "11" Then
                            If Variables.FingerArray.Contains(sl(1)) Then Variables.FingerArray.Remove(sl(1))
                            Variables.FingerArray.Add(sl(1), result)
                            Form1.Finger1Combo.Items.Add(sl(2))
                            Form1.Finger2Combo.Items.Add(sl(2))
                        ElseIf sl(0) = "12" Then
                            If Variables.TrinketArray.Contains(sl(1)) Then Variables.TrinketArray.Remove(sl(1))
                            Variables.TrinketArray.Add(sl(1), result)
                            Form1.Trinket1Combo.Items.Add(sl(2))
                            Form1.Trinket2Combo.Items.Add(sl(2))
                        ElseIf sl(0) = "13" Or sl(0) = "17" Or sl(0) = "21" Then ' Mainhand
                            If Variables.MainHandArray.Contains(sl(1)) Then Variables.MainHandArray.Remove(sl(1))
                            Variables.MainHandArray.Add(sl(1), result)
                            Form1.MainHandCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "14" Or sl(0) = "23" Then ' Offhand
                            If Variables.OffHandArray.Contains(sl(1)) Then Variables.OffHandArray.Remove(sl(1))
                            Variables.OffHandArray.Add(sl(1), result)
                            Form1.OffHandCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "16" Then
                            If Variables.BackArray.Contains(sl(1)) Then Variables.BackArray.Remove(sl(1))
                            Variables.BackArray.Add(sl(1), result)
                            Form1.BackCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "28" Then ' Relic
                            If Variables.RelicArray.Contains(sl(1)) Then Variables.RelicArray.Remove(sl(1))
                            Variables.RelicArray.Add(sl(1), result)
                            Form1.RelicCombo.Items.Add(sl(2))
                        End If
                    End If
                End If
            Next
            Form1.sortGearDropDown()
            ItemTextBox.Text = ""
            MessageBox.Show("Process complete.")
            Me.Close()
        Else
            MessageBox.Show("Selection box empty.")
        End If
    End Sub

    Private Sub GearReimportButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GearReimportButton.Click
        Dim TempHash As Hashtable = Variables.AllItemsArray_Name.Clone
        For Each item In TempHash
            Dim a() As String = Split(item.value, ";")
            Dim result As String = ""
            Try
                If (a(1).Substring(0, 1) <> "r") Then result = Armory.CheckItemDB(a(1), "-1") ' Skip reforged items.
            Catch ex As Exception
                Form1.TextBox1.AppendText("Failed.  Preserving existing item." & vbCrLf)
            End Try
        Next
        MessageBox.Show("Import process complete.  Check Results tab for result.")
        Me.Close()
    End Sub
End Class