﻿Public Class ItemImporter_Gem
    Private Sub GemImportButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GemImportButton.Click
        If GemTextBox.Text <> "" Then
            Dim items() As String = Split(GemTextBox.Text, ";")
            Dim item As String = ""
            For Each item In items
                If item <> "" Then
                    Dim result As String = ""
                    result = Armory.parseGemFromWowhead(item)
                    Dim s() As String = Split(result, ";")
                    If Variables.GemHash_Id.Contains(item) Then
                        Variables.GemHash_Id.Remove(item)
                        Variables.GemHash_Name.Remove(s(1))
                    End If
                    Variables.GemHash_Id.Add(item, result)
                    Variables.GemHash_Name.Add(s(1), result)
                    If s(2) = "0" Or s(2) = "3" Or s(2) = "5" Then
                        If Form1.DefRedGem.Items.Contains(s(1)) Then Form1.DefRedGem.Items.Add(s(1) & " (" & s(0) & ")") Else Form1.DefRedGem.Items.Add(s(1))
                    End If
                    If s(2) = "1" Or s(2) = "3" Or s(2) = "4" Then
                        If Form1.DefBlueGem.Items.Contains(s(1)) Then Form1.DefBlueGem.Items.Add(s(1) & " (" & s(0) & ")") Else Form1.DefBlueGem.Items.Add(s(1))
                    End If
                    If s(2) = "2" Or s(2) = "4" Or s(2) = "5" Then
                        If Form1.DefYellowGem.Items.Contains(s(1)) Then Form1.DefYellowGem.Items.Add(s(1) & " (" & s(0) & ")") Else Form1.DefYellowGem.Items.Add(s(1))
                    End If
                    If s(2) = "6" Then
                        If Form1.DefMetaGem.Items.Contains(s(1)) Then Form1.DefMetaGem.Items.Add(s(1) & " (" & s(0) & ")") Else Form1.DefMetaGem.Items.Add(s(1))
                    End If
                    If s(2) <> "6" Then
                        If Form1.DefPrisGem.Items.Contains(s(1)) Then Form1.DefPrisGem.Items.Add(s(1) & " (" & s(0) & ")") Else Form1.DefPrisGem.Items.Add(s(1))
                    End If
                End If
            Next
            GemTextBox.Text = ""
            MessageBox.Show("Process complete.")
            Me.Close()
        Else
            MessageBox.Show("Selection box empty.")
        End If
    End Sub

    Private Sub GemReimportButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GemReimportButton.Click
        Dim TempHash As Hashtable = GemHash_Name.Clone
        For Each item In TempHash
            Dim a() As String = Split(item.value, ";")
            Form1.TextBox1.AppendText("Attempting to reimport: " & a(1) & " (ID:" & a(0) & ")...")
            Dim result As String = ""
            Try
                result = Armory.parseGemFromWowhead(a(0))
                Variables.GemHash_Id.Remove(a(0))
                Variables.GemHash_Name.Remove(a(1))
                Form1.TextBox1.AppendText("Done." & vbCrLf)
            Catch ex As Exception
                Form1.TextBox1.AppendText("Failed.  Preserving existing item." & vbCrLf)
            End Try
        Next
        MessageBox.Show("Import process complete.  Check Results tab for result.")
        Me.Close()

    End Sub
End Class